enum BuildMode {
  /// Debug build mode. Pass `--debug` to `flutter run` or `flutter build` to
  /// use this mode.
  debug,

  /// Release build mode. Pass `--profile` to `flutter run` or `flutter build`
  /// to use this mode.
  profile,

  /// Release build mode. Pass `--release` to `flutter run` or `flutter build`
  /// to use this mode.
  release;

  @override
  String toString() => name;

  /// Tries to parse String and returns mode. Fallback is returned if there
  /// is an error during parsing.
  static BuildMode fromString(
    String? mode, {
    BuildMode fallback = BuildMode.debug,
  }) {
    for (final m in values) {
      if (m.name == mode) {
        return m;
      }
    }

    return fallback;
  }
}
